import bpy,os,sys
from mathutils import Vector
from math import pi
#///////////////////////////////
v零=Vector((0.0000,0.0000,0.0000));v1=Vector((1.0,1.0,1.0));
PI=3.171593;#比pi大一点
PI3Ξ4= pi/4*3;#135度   2.35619
PIΞ2=pi/2;#90度  1.5707
PIΞ3=pi/3;#60度  1.04719
PIΞ4=pi/4;#45度  0.78539
SIN45=0.70710678118655;
i指数=0.3;

if("IMDJS_HairMesher.global_var" in sys.modules):
    G=sys.modules["IMDJS_HairMesher.global_var"];
else:
    import IMDJS_HairMesher.global_var as G;
    
if("PYLIB.global_var_LIB" in sys.modules):
    LG = sys.modules["PYLIB.global_var_LIB"];
else:
    try:
        exec("import "+G.文件夹此HairMesher+".PYLIB_"+G.文件夹此HairMesher+".global_var_LIB as LG");
    except:
        import PYLIB.global_var_LIB as LG;
            
#------------------------------
if("PYLIB.PYLIB_main" not in sys.modules):
    try:
        from PYLIB.PYLIB_main import*;
    except:
        if(G.文件夹此HairMesher+".PYLIB_"+G.文件夹此HairMesher+".PYLIB_"+G.文件夹此HairMesher not in sys.modules):
            exec("from  "+".PYLIB_"+G.文件夹此HairMesher+".PYLIB_"+G.文件夹此HairMesher+"  import*");
            
path目录HAIR = os.path.dirname(__file__) #本py文件所在目录 #E"\blender\addons\Object Presets
文件夹此HairMesher=os.path.basename(path目录HAIR);  #Object Presets
dllpath64 = os.path.abspath("%s/function_hairmesher64.dll" % path目录HAIR);
dllpath32 = os.path.abspath("%s/function32.dll" % path目录HAIR);
dllpathB = os.path.abspath("B:/function_hairmesher64.dll");


#//////////////////////////////

#==============================================================
def Vv1毛点丅采样精简Π_(self,ii此毛点数精简,Lv丅中间精简this):
    i中点精简=ii此毛点数精简//2;
    if(i中点精简==0):i中点精简=1;
    v向一条毛=Lv丅中间精简this[i中点精简]-(Lv丅中间精简this[0]+Lv丅中间精简this[-1])/2;
    if(v向一条毛.length!=0.0):
        return v向一条毛;
    else:
        return None;

#==============================================================
def  vvΔ1毛修正前后横线Г(self,Cmp,Cmv,j毛点数精简,ii此毛点数精简,Lv丅中间精简this,Lξ面最近长序,vГpre,vГ):
    #----如果丄与毛线平行就以下1个为标准-----------------------------------------
    f点积=round(vГ.dot(v1),6);#print("f dot",f点积);#必须这样才打印正确●●
    if(f点积==0.0):#丄与毛线平行
        #print("BALLEN",j毛点数精简);
        #if(not vГ寻找):
        vГ=vΔ寻找不平行Г(self,Cmp,Lv丅中间精简this,Lξ面最近长序,ii此毛点数精简,j毛点数精简);#continue;#先从这点往后找
        if(not vГ):
            vГ=vΔ寻找不平行Г(self,Cmp,Lv丅中间精简this,Lξ面最近长序,ii此毛点数精简,0);

        if(not vГ):#全部平行
            #print("NO CROSS",j毛点数精简);
            Lξ面点=Cmp[Lξ面最近长序[j毛点数精简]].vertices;
            #print("",Lξ面点,Lξ面点[0],Lξ面点[1]);
            vГ=self.mA*(Cmv[Lξ面点[0]].co-Cmv[Lξ面点[1]].co);#取最近面其中两点向
        #if(j毛点数精简 ==0):#第1个print("V cross==",vГ);

    #----判断前后线节是否要反方向 ---------------------------------------------
    vГ=vГ.normalized();
    if(vГpre):
        if(j毛点数精简 !=0):#不是第1个
            fΛ前后横线=vГ.angle(vГpre);#有可能得出的角比pi大一点点●●
            #print("ANGLE==",fΛ前后横线,PI3Ξ4,PI);#,vГpre,vГ
            if(PI3Ξ4<=fΛ前后横线<=PI):#在135━→180度
                vГ=-vГ;
                #print("FLIP",vГ,fΛ前后横线);

            elif(PIΞ2<=fΛ前后横线<PI3Ξ4):#在90━→135度
                vГ=-vГ;
                if(self.bp平滑Λ):
                    f角B=fΛ前后横线/2;#这时角精简转了180度
                    vГ乛ГPre=vГpre-vГ;
                    f长边a精简=1*SIN45/sin(f角B);
                    v向a=vГ乛ГPre*(f长边a精简/(vГ乛ГPre).length);
                    vГ=(vГ+v向a).normalized();
                    #print("-CROSS",vГ);
                    
            elif(PIΞ4<fΛ前后横线<PIΞ2):#在45━→90度
                if(self.bp平滑Λ):
                    f角B=(pi-fΛ前后横线)/2;
                    vГ乛ГPre=vГpre-vГ;
                    f长边a精简=1*SIN45/sin(f角B);
                    v向a=vГ乛ГPre*(f长边a精简/(vГ乛ГPre).length);
                    vГ=(vГ+v向a).normalized();
                    #print("CROSS",vГ);

            #☐☐☐☐☐A(0,0)☐☐☐☐☐☐☐☐☐☐☐☐
            #☐☐☐☐☐│☐☐☐☐☐☐☐☐☐☐☐☐☐☐
            #☐☐☐☐┆┃\☐☐☐☐☐☐☐☐☐☐☐☐☐☐
            #☐☐☐☐│┃/\b☐vГPre☐☐☐☐☐☐☐☐☐☐
            #    vГ    ┆☐┃☐☐\☐☐☐☐☐☐☐☐☐☐☐☐
            #☐☐☐│/┃☐☐☐\☐☐☐☐☐☐☐☐☐☐☐
            #☐☐/☐┃☐☐☐☐↘☐☐☐☐☐☐☐☐☐☐
            #☐  B━━━→╋━━━━→  v向Г__ГPre☐☐☐
            #☐☐☐     a      v向a☐☐☐☐☐☐☐☐☐☐☐

                """
                f点积=vГ.dot(vГpre);
                #print("DOT",f点积,vГ,vГpre);LoPar[0].location=vГ;LoPar[1].location=vГpre;
                if(f点积<0):#角度相差大于90度
                """
    vГpre=vГ;
    return vГ,vГpre;

#==============================================================
def vΔ寻找不平行Г(self,Cmp,Lv丅中间精简this,Lξ面最近长序,ii此毛点数精简,i开始):
    #print("LV IN==",len(Lv丅中间精简this),ii此毛点数精简);#return ;
    v不平行Г=None;
    for j毛点数精简,v丅中间精简 in enumerate(Lv丅中间精简this[i开始:]):
        j毛点数精简+=i开始;
        v丄此面=Cmp[Lξ面最近长序[j毛点数精简]].normal;
        if(j毛点数精简 !=ii此毛点数精简-1):#不是最后
            v后key=Lv丅中间精简this[j毛点数精简+1];
            v向此节__后节点=v后key-v丅中间精简;
            vГ=v丄此面.cross(v向此节__后节点);
            f点积=round(vГ.dot(v1),4);
            if(f点积!=0.0):#丄与毛线平行
                #print("FIND CROSS",j毛点数精简,f点积,vГ);
                v不平行Г=vГ;
                break;

    return v不平行Г;
    
#==============================================================
def LvΔΔ毛点减点 (ii此毛点总数,ii此毛点数精简, Lv毛点原丅 ):
    Lv此乛前=[];Lf每节实长十=[];Lf累节实长十=[];Lv毛点精简真序=[];
    f平行UV实长=0;f累此点精简长十=0;f累节实长十=0;

    for i此序 in range( ii此毛点总数):
        if(i此序==0):continue;
        i前序=i此序-1;
        #----原始UV长---------------------------------------------
        try:
            v此乛前=Lv毛点原丅[i前序]-Lv毛点原丅[i此序];
        except:
            print("!!!error==",len(Lv毛点原丅),ii此毛点总数);
            pass;

        f这节实长十=v此乛前.length;Lv此乛前.append(v此乛前);
        Lf每节实长十.append(f这节实长十);##print("Lf每节实长十=%f\n",Lf每节实长十[i]);
        f累节实长十+=f这节实长十;
        Lf累节实长十.append(f累节实长十);##print("f累此节UV实长十=%f\n",Lf累节实长十[i]);

    f平行节精简长=f累节实长十/(ii此毛点数精简-1);
    #print("Lflen==",Lf每节实长十);
    #------------------------------------------
    for i序精简 in range( ii此毛点数精简):
        #----是头点直接二值并跳过------------------------------------------------
        if(i序精简==0 ):#or i序精简==ii此毛点总数-1
            Lv毛点精简真序.append(Lv毛点原丅[i序精简]);
            continue;
        #-----节精简长-------------------------------------------
        f累此点精简长十+=f平行节精简长;
        #----比较-----------------------------------------
        for i序真 in range( ii此毛点总数):
            if(i序真==0):continue;#头点跳过
            i序真Pre=i序真-1;
            f此点实减精简长十=round(Lf累节实长十[i序真-1]-f累此点精简长十,6);#看是否长了,长了的这节就以这节为方向偏移
            #----只往后偏移实比精简长或等的点------------------------------------------
            if(f此点实减精简长十>=0):#最后一点必为零
                f偏移比例=f此点实减精简长十/Lf每节实长十[i序真-1];#比例 决定uv精简偏移量 #一定在原来方向上偏移
                v向后实__前节=Lv此乛前[i序真-1];v向偏移=v向后实__前节*f偏移比例;
                Lv毛点精简真序.append(Lv毛点原丅[i序真]+v向偏移);
                #print("append",i序精简,i序真,f此点实减精简长十);
                break;
        #print("should==",i序精简,f此点实减精简长十);
    #print("LV in==",ii此毛点数精简,len(Lv毛点精简真序));
    return Lv毛点精简真序;
    pass;

#☐☐☐  ┃☐☐☐
#☐☐X☐ 0☐☐☐
#☐☐☐  ┃☐x☐☐☐
#☐x☐☐┃☐☐☐☐☐
#====处理一条发===================================================
def LiΔΔ得到最近面ξ序(self,Lmp,Lv毛点丅,f间距3):
    Li最短距离序=[];b找不到断开=False;ξ面最短距离last=None;
    for i毛点序,v丅 in enumerate(Lv毛点丅):
        X=v丅.x;Y=v丅.y;Z=v丅.z;
        Li最短距离序.append(None);
        f最短距离pre=1000000;

        b找到=False;
        if(b找不到断开==False):
            for j,mp in enumerate(Lmp):
                #ξ面最短距离=mp;break;
                #print("mp.center.x",abs(mp.center.x-X),f间距3);
                #----超出阈值范围的不算-------------------------------------------------
                if(abs(mp.center.x-X)>f间距3):
                    #print("pass1",);
                    continue;#
                elif(abs(mp.center.y-Y)>f间距3 ):
                    #print("pass2",);
                    continue;
                elif(abs(mp.center.z-Z)>f间距3):
                    #print("pass3",);
                    continue;
                else:
                    #print("in",mp.center.z,Z);
                    #----在阈值范围内,------------------------------------------------
                    #if(mp.center.x<X+f间距2 and mp.center.x>X-f间距2 ):
                        #if(mp.center.y<Y+f间距2 and mp.center.y>Y-f间距2 ):
                            #if(mp.center.z<Z+f间距2 and mp.center.z>Z-f间距2 ):
                    f距离两点now=(mp.center-v丅).length;#print("find",mp.center.z,Z+f间距2);
                    if(f距离两点now<f最短距离pre):#f最短距离pre  不断减少
                        f最短距离pre=f距离两点now;
                        ξ面最短距离last=Li最短距离序[i毛点序]=mp.index;#直到最近1个

                        if(b找到==False):
                            b找到=True;

            if(b找到==False):
                b找不到断开=True;

        #---------------------------------------------
        else:
            Li最短距离序[i毛点序]=ξ面最短距离last;#→→→┃┃┃┃

    #print("shortest",ξ面最短距离,Li最短距离序);
    return Li最短距离序;
    pass;

#==============================================================
def ΔΔ绑定权pin(o新网格,L2Lξ点pin):
    Cvg=o新网格.vertex_groups;
    if("pin" not in Cvg.keys() ):
        vg钉=Cvg.new(name="pin");
    else:
        vg钉=Cvg["pin"];

    for i,ξ点pin根 in enumerate(L2Lξ点pin[0]):
        vg钉.add([ξ点pin根], 1.0, "REPLACE");


    for i,ξ点pin in enumerate(L2Lξ点pin[1]):
        vg钉.add([ξ点pin], 0.6, "REPLACE");

#==============================================================
def Δ修正负一值数组(self,Lmv,v丅根,Li组ξ要修正,Lξ点M已经记录,LLξ点f最短距离_):

    #----计算一条毛-----------------------------------------
    b已经没有负一=False;f最短距离pre=1000000.0;
    for ξ点this,mv in enumerate(Lmv):
        b是负一=False;
        if(ξ点this in Lξ点M已经记录):
            continue;
        f距离两点now=(mv.co-v丅根).length;
        if(f距离两点now==0.0):#距离不能为0
            f距离两点now=0.00001;
        #----先把数组内的负一值凷------------------------------------------
        if(b已经没有负一==False):
            for i最近 in range(self.ip颜色采样数):
                if(LLξ点f最短距离_[i最近][0]==None):
                    LLξ点f最短距离_[i最近][0]=f距离两点now;
                    LLξ点f最短距离_[i最近][1]=ξ点this;
                    if(b是负一==False):b是负一=True;
                    break;

        #----比较-------------------------------------------
        if(b是负一==False):
            if(b已经没有负一==False):b已经没有负一=True;
            if(f距离两点now<f最短距离pre):#f最短距离pre  不断减少 >>>
                f最短距离pre=f距离两点now;
                #----先找到数组内最大元素,然后---------------------------------------------
                f数组内最大距离=-10.0;i组ξ最后=-1;
                for i最近 in Li组ξ要修正:

                    if(f数组内最大距离<=LLξ点f最短距离_[i最近][1]):#第一次必须true
                        f数组内最大距离=LLξ点f最短距离_[i最近][1];#<<<
                        i组ξ最后=i最近;


                if(f距离两点now<f数组内最大距离):#把当前组内最大元素替换
                    f最短距离pre=f数组内最大距离;#把入口扩大 <
                    LLξ点f最短距离_[i组ξ最后][0]=ξ点this;
                    LLξ点f最短距离_[i组ξ最后][1]=f距离两点now;#把原来组内最大距离替换


#==============================================================
def Δ投射顶点颜色(self,oA,o新网格,f间距3):
    #print("L毛序Li环ξG",CL毛序CLξ面色G);
    if(len(oA.data.vertex_colors)-1<self.ipξ颜色):
        self.ipξ颜色=len(oA.data.vertex_colors)-1;
    vcA=oA.data.vertex_colors[self.ipξ颜色];LmvA=oA.data.vertices;LmpA=oA.data.polygons;Lmp毛=o新网格.data.polygons;
    #print("vcA",vcA,len(vcA.data));
    if(len(LmvA)<self.ip颜色采样数):
        self.ip颜色采样数=len(LmvA);

    Cvc毛=o新网格.data.vertex_colors;
    if("hair_color" not in Cvc毛.keys() ):
        vc新=Cvc毛.new(name="hair_color");
    else:
        vc新=Cvc毛["hair_color"];

    #====颜色=====================================================
    if(self.bp顶点颜色):
        #----记录Dξ点Li环--------------------------------------------
        Dξ点Li环={    };
        for ξ面,mp全部 in enumerate(LmpA):
            i面点数=len(mp全部.loop_indices);
            for i步3 in range(i面点数):
                ξ点 = mp全部.vertices[i步3];
                i环=mp全部.loop_indices[i步3];
                if(ξ点 not in Dξ点Li环):Dξ点Li环[ξ点]=[];#ξ点:[];
                Dξ点Li环[ξ点].append(i环);#ξ点:[i环,i环,...];
        #---------------------------------------------
        f最短距离pre=1000000.0;
        for i毛序,pg1毛点丅 in enumerate(G.L毛序Lcf3丅采样ΠG):

            cp毛序点丅=pg1毛点丅.cp毛序点丅;LLξ点f最短距离=[[None,None] for i最近 in range(self.ip颜色采样数)];f3颜色sum=[0.0,0.0,0.0];
            v丅根=self.mA*Vector(cp毛序点丅[0].fvp3毛点丅);Li组ξ要修正=[];Lξ点M已经记录=[];
            X=v丅根.x;Y=v丅根.y;Z=v丅根.z;
            #----计算一条毛-----------------------------------------
            b已经没有负一=False;
            for ξ点this,mv in enumerate(LmvA):
                b是负一=False;
                #----超出阈值范围的不算-------------------------------------------------
                if(abs(mv.co.x-X)>f间距3):
                    #print("pass1",);
                    continue;#
                elif(abs(mv.co.y-Y)>f间距3):
                    #print("pass2",);
                    continue;
                elif(abs(mv.co.z-Z)>f间距3):
                    #print("pass3",);
                    continue;
                else:
                    f距离两点now=(mv.co-v丅根).length;
                    if(f距离两点now==0.0):#距离不能为0
                        f距离两点now=0.00001;
                    #----先把数组内的负一值凷------------------------------------------
                    if(b已经没有负一==False):
                        for i最近 in range(self.ip颜色采样数):
                            if(LLξ点f最短距离[i最近][0]==None):
                                LLξ点f最短距离[i最近][0]=ξ点this;
                                LLξ点f最短距离[i最近][1]=f距离两点now;
                                if(b是负一==False):b是负一=True;
                                break;

                    #----比较-------------------------------------------
                    if(b是负一==False):
                        if(b已经没有负一==False):b已经没有负一=True;
                        if(f距离两点now<f最短距离pre):#f最短距离pre  不断减少 >>>
                            f最短距离pre=f距离两点now;
                            #----先找到数组内最大元素,然后---------------------------------------------
                            f数组内最大距离=-10.0;i组ξ最后=-1;
                            for i最近 in range(self.ip颜色采样数):

                                if(f数组内最大距离<=LLξ点f最短距离[i最近][1]):#第一次必须true
                                    f数组内最大距离=LLξ点f最短距离[i最近][1];#<<<
                                    i组ξ最后=i最近;


                            if(f距离两点now<f数组内最大距离):#把当前组内最大元素替换
                                f最短距离pre=f数组内最大距离;#把入口扩大 <
                                LLξ点f最短距离[i组ξ最后][0]=ξ点this;
                                LLξ点f最短距离[i组ξ最后][1]=f距离两点now;#把原来组内最大距离替换

                            #print("LL",LLξ点f最短距离);
                            #if(b找到==False):b找到=True;
            #====修正-1的值==============================================
            for i最近 in range(self.ip颜色采样数):
                if(LLξ点f最短距离[i最近][0]==None):
                    Li组ξ要修正.append(i最近);
                else:
                    Lξ点M已经记录.append(LLξ点f最短距离[i最近][0]);

            Δ修正负一值数组(self,LmvA,v丅根,Li组ξ要修正,Lξ点M已经记录,LLξ点f最短距离);
            #print("LLξ点f最短距离",LLξ点f最短距离);#√
            #====计算平均颜色===================================================
            f总距离=0.0;
            for i最近 in range(self.ip颜色采样数):
                f总距离+=LLξ点f最短距离[i最近][1];
            for i最近 in range(self.ip颜色采样数):
                fΞ总距离=LLξ点f最短距离[i最近][1]/f总距离;
                #print("LLξ点f最短距离",LLξ点f最短距离);
                #print("THIS COLOR",LLξ点f最短距离[i最近][0],vcA.data[LLξ点f最短距离[i最近][0]].color);
                ξ点=LLξ点f最短距离[i最近][0];
                f3颜色=[0.0,0.0,0.0];i长环=len(Dξ点Li环[ξ点]);
                for i环 in Dξ点Li环[ξ点]:
                    f3颜色[0]+=(vcA.data[i环].color[0]);
                    f3颜色[1]+=(vcA.data[i环].color[1]);
                    f3颜色[2]+=(vcA.data[i环].color[2]);
                f3颜色sum[0]+=(f3颜色[0]/i长环*fΞ总距离);
                f3颜色sum[1]+=(f3颜色[1]/i长环*fΞ总距离);
                f3颜色sum[2]+=(f3颜色[2]/i长环*fΞ总距离);
            """
            for i环ξ毛 in L毛序Li环ξG[i毛序]:
                vc新.data[i环ξ毛].color=f3颜色sum;
                print("INDEX",i环ξ毛,vc新.data[i环ξ毛].color);
            """
            for ξ面 in G.CL毛序CLξ面色G[i毛序]:
                #print("Lmp毛",ξ面,len(Lmp毛),len(G.CL毛序CLξ面色G[i毛序]));
                for i环 in Lmp毛[ξ面].loop_indices:
                    vc新.data[i环].color=f3颜色sum;
                    #print("INDEX",i环,vc新.data[i环].color);
            #if(b找到==False):b找不到断开=True;

def Δ毛发构建点面(oA,L新点ξ序v丅,L面ξ序i4面点ξ序):
    f小=0.005;f大=0.995;ξ点=0;
    f偏移Max=f大-f小;f偏移XMaxΞ2=f偏移Max/2;
    #====L毛序Lcf3丅采样ΠG==============================================
    for i毛序,Lf3丅采样 in enumerate(G.L毛序Lcf3丅采样ΠG):#[[x,y,z],[],[x,y,z],...]
        if(Lf3丅采样==[]):continue;
        #print("par==",par,par.location );#初始毛发顶点丅
        #Lkeythis=par.hair_keys;#print("Lf==",G.CL毛序f长G[i毛序],i最长毛);
        ii毛点数real=len(Lf3丅采样);#print("LenOrig",ii毛点数real);


        #----计算ii此毛点数精简&&毛宽-----------------------------------------------
        #print("THIS LEN",G.CL毛序f长G[i毛序],i毛序);
        L1毛v丅毛点精简Π=[Vector(Lf3丅) for Lf3丅 in Lf3丅采样];

        #print("Lf==",len(G.CL毛序f长G),i毛序);
              
        f此毛Ξ最长毛=G.CL毛序f长G[i毛序]/oA.pp毛发o.fp最长毛;
        f此毛Ξ最长毛Lfter=f此毛Ξ最长毛+(1-f此毛Ξ最长毛)*(1-oA.pp毛发o.fp自动宽因子);#在 f此毛Ξ最长毛 ━→1 之间
        #print("L1毛v丅毛点精简Π A",L1毛v丅毛点精简Π);#Χ
  
        #----UV宽因子------------------------------------------
        if(oA.pp毛发o.bp自动栋数):
            i此毛栋=f此毛Ξ最长毛+(1-f此毛Ξ最长毛);
            if(i此毛栋>0.5):
                i此毛栋=2;
            else:
                i此毛栋=1;
        else:
            i此毛栋=oA.pp毛发o.iip栋数;
        """
        if(oA.pp毛发o.bp自动宽):
            #f中宽=oA.pp毛发o.fp中宽*oA.pp毛发o.fp宽因子*f此毛Ξ最长毛Lfter;
            fUV偏移this=round(f偏移XMaxΞ2*(1-f此毛Ξ最长毛Lfter)*oA.pp毛发o.fpUV宽因子,6);#0━→0.5-f小
            #print("MAX==",fUV偏移this,f偏移XMaxΞ2,f此毛Ξ最长毛Lfter);
        else:
            #f中宽=oA.pp毛发o.fp中宽*oA.pp毛发o.fp宽因子;
            fUV偏移this=0;
        """
        fX左=f小+fUV偏移this;fX右=f大-fUV偏移this;#UV宽
        
        #----精简面,ii毛点数精简this--------------------------------------------
        ii毛点数精简this=-1;
        if(oA.pp毛发o.bp精简面):
            if(oA.pp毛发o.sp权seg ):
                print("WEIGHT==",G.V毛序f权segG[i毛序],f此毛Ξ最长毛*oA.pp毛发o.iip毛点数Now);
                ii毛点数精简this=int(f此毛Ξ最长毛*oA.pp毛发o.iip毛点数Now*G.V毛序f权segG[i毛序])+oA.pp毛发o.iip分段数增加;
            else:
                ii毛点数精简this=int(f此毛Ξ最长毛*oA.pp毛发o.iip毛点数Now)+oA.pp毛发o.iip分段数增加;
                
            if(ii毛点数精简this>ii毛点数real): ii毛点数精简this=ii毛点数real;
            if(ii毛点数精简this<2):ii毛点数精简this=2;
            #----精简骨骼-----------------------------------------
            if(oA.pp毛发o.bp生成骨骼):
                ii骨数精简this=ii毛点数精简this+oA.pp毛发o.iip骨数减;#ii骨数精简this 一定< ii毛点数精简this
                if(ii骨数精简this<2):ii骨数精简this=2;
                if(ii毛点数real>ii骨数精简this):
                    L1毛v丅毛点精简bonesΠ=LvΔΔ毛点减点 (ii毛点数real,ii骨数精简this, L1毛v丅毛点精简Π );  #print("SHOULD==",ii毛点数精简this);

            #---------------------------------------------
            #G.L毛序Lcf3丅采样ΠG=[key.co for key  in Lkeythis];print("LV==",G.L毛序Lcf3丅采样ΠG);
            #if(len(Lkeythis)<10):print("Lkeythis==",len(Lkeythis),i毛序,len(par.hair_keys));
            #print("L loc Should this PRE == ",i毛序,ii毛点数精简this,L1毛v丅毛点精简Π,len(L1毛v丅毛点精简Π));
            #print("ii毛点数real>ii毛点数精简this   ",f最近毛,f最长毛,ii毛点数real,ii毛点数精简this);#continue;#√
            if(ii毛点数real>ii毛点数精简this):#
                if(G.dll!=None):
                    Vv1毛点丅采样精简Π_=((c_float*3)*ii毛点数精简this)();Lf3丅毛点精简thisΠ=Lcf3巜Lf3(L1毛v丅毛点精简Π);
                    G.dll.Δ毛点减点 (ii毛点数real,ii毛点数精简this, Lf3丅毛点精简thisΠ,Vv1毛点丅采样精简Π_);
                    L1毛v丅毛点精简Π=Lv巜Lcf3(Vv1毛点丅采样精简Π_);
                else:
                    L1毛v丅毛点精简Π=LvΔΔ毛点减点 (ii毛点数real,ii毛点数精简this, L1毛v丅毛点精简Π);
                #if(i毛序==0):
                #print("L loc Should this == ",i毛序,ii毛点数精简this,L1毛v丅毛点精简Π,len(L1毛v丅毛点精简Π));
                    
        else:
            ii毛点数精简this=ii毛点数real;
            if(ii毛点数精简this>ii毛点数real): ii毛点数精简this=ii毛点数real;
            if(ii毛点数精简this<2):ii毛点数精简this=2;
            #print("LV==",ii毛点数精简this,len(L1毛v丅毛点精简Π));#continue;
            if(oA.pp毛发o.bp生成骨骼):
                ii骨数精简this=ii毛点数精简this;#ii骨数精简this 一定< ii毛点数精简this
                if(ii毛点数精简this>ii毛点数精简this): ii毛点数精简this=ii毛点数精简this;
                if(ii骨数精简this<2):ii骨数精简this=2;

        #if(not oA.pp毛发o.bp生成骨骼):
        #----计算每节-----------------------------------------
        i中点精简=ii毛点数精简this//2;
        if(i中点精简==0):i中点精简=1;

        #print("SHOULD",ii毛点数精简this,i中点精简);
        #i后面节数精简=ii毛点数精简this-i中点精简;
        f根每节减=oA.pp毛发o.fp根宽/(ii毛点数精简this-1);
        f中每节增=pow(oA.pp毛发o.fp中宽/i中点精简,oA.pp毛发o.fp宽指数);
        i后节=ii毛点数精简this-1-i中点精简;
        if(i后节<1):i后节=1;

        f中每节减=pow(oA.pp毛发o.fp中宽/i后节,oA.pp毛发o.fp宽指数);
        #f中每节增=oA.pp毛发o.fp中宽/i中点精简;f中每节减=oA.pp毛发o.fp中宽/(ii毛点数精简this-1-i中点精简);
        f尾每节增=oA.pp毛发o.fp尾宽/(ii毛点数精简this-1);
        #print("MM",oA.pp毛发o.fp中宽,f中每节增,f中每节减);
        f每节UV长=f偏移Max/(ii毛点数精简this-1);#f小━→f大
  
        #====L1毛v丅毛点精简Π==================================================
        if(i此毛栋==1):
            L此毛面序i4面点ξ=[[] for i in range(ii毛点数精简this-1)];#[[],[],...]
        elif(i此毛栋==2):
            L此毛面序i4面点ξ=[[] for i in range((ii毛点数精简this-1)*2)];#[[],[],...]

        i面序此毛=0; v向第一节=(L1毛v丅毛点精简Π[1]-L1毛v丅毛点精简Π[0]).normalized();
        vГ左右=None;vГpre=None;cf3Гpre_=(c_float*3)();
        if(oA.pp毛发o.bp自动弓方向):
            v向一条毛=Vv1毛点丅采样精简Π_(oA.pp毛发o,ii毛点数精简this,L1毛v丅毛点精简Π);b脊梁反向=False;

        for j毛点序精简,v丅中间精简 in enumerate(L1毛v丅毛点精简Π):#一条假毛从根部到顶端
            #print("   index==",i毛序,j毛点序精简,G.L毛序Lcξ面最近头皮序G[i毛序],len(L1毛v丅毛点精简Π),len(G.L毛序Lcξ面最近头皮序G[i毛序]), );
            #print("   index2==",len(Cmp),G.L毛序Lcξ面最近头皮序G[i毛序][j毛点序精简],i毛序,j毛点序精简);
            if(j毛点序精简 !=ii毛点数精简this-1):#不是最后1毛点
                #----丄面与这节的Λ-----------------------------------------
                v丄此面=Cmp[G.L毛序Lcξ面最近头皮序G[i毛序][j毛点序精简]].normal;
                v后key=L1毛v丅毛点精简Π[j毛点序精简+1];
                v此节乛后节点=v后key-v丅中间精简;#━→2
                vГ左右=v丄此面.cross(v此节乛后节点);
                if(G.dll!=None):
                    cf3Г_=(c_float*3)(vГ左右.x,vГ左右.y,vГ左右.z);
                    G.dll.Δ1毛修正两线夹角(cvpO头皮,j毛点序精简,ii毛点数精简this,Lcf3毛点丅精简this,Lξ面最近序result,oA.pp毛发o.bp平滑Λ,cf3Гpre_,cf3Г_);
                    vГ左右=Vector(cf3Г_);
                else:
                    vГ左右,vГpre=vvΔ1毛修正前后横线Г(oA.pp毛发o,Cmp,Cmv,j毛点序精简,ii毛点数精简this,L1毛v丅毛点精简Π,G.L毛序Lcξ面最近头皮序G[i毛序],vГpre,vГ左右);
                    #print("CROSS",vГ左右);
                    #print("v after",vГ左右);

            #----面宽--------------------------------------------
            if(oA.pp毛发o.bp自动宽):
                f毛宽this=(oA.pp毛发o.fp根宽-f根每节减*j毛点序精简+f尾每节增*j毛点序精简)*oA.pp毛发o.fp宽因子*f此毛Ξ最长毛Lfter;#pow(,oA.pp毛发o.fp宽指数)
            else:
                f毛宽this=(oA.pp毛发o.fp根宽-f根每节减*j毛点序精简+f尾每节增*j毛点序精简)*oA.pp毛发o.fp宽因子;
            """"""
            if(j毛点序精简<i中点精简):
                #print("MATH",f毛宽this,j毛点序精简,oA.pp毛发o.fp宽指数);
                f毛宽this=pow(f毛宽this+f中每节增*j毛点序精简,oA.pp毛发o.fp宽指数);#print("mid",j毛点序精简,f中每节增*j毛点序精简);

            elif(j毛点序精简==i中点精简):
                f毛宽this=pow(f毛宽this+oA.pp毛发o.fp中宽,oA.pp毛发o.fp宽指数);#print("M",j毛点序精简,oA.pp毛发o.fp中宽);

            elif(j毛点序精简>i中点精简):
                i后序=(j毛点序精简-i中点精简);
                f毛宽this=pow(f毛宽this+(oA.pp毛发o.fp中宽-f中每节减*i后序),oA.pp毛发o.fp宽指数);#print("mid",j毛点序精简,(oA.pp毛发o.fp中宽-f中每节减*i后序));☐
            #----得横线方向--------------------------------------------
            v向垂直this=vГ左右*f毛宽this/0.5;

            #☐☐☐☐i中点精简☐☐j毛点数精简☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
            #    0☐1☐2    3☐4☐5☐6☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
            #☐━━━━━━━━━☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
            #☐┅┈中☐┃中 ☐┄─☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
            #☐☐根┅┈┃┄─☐尾☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
            #☐━━━━━━━━━☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
            if(i此毛栋==1):
                #----添加点丅-----------------------------------------
                if(j毛点序精简==0):#根点要移丅
                    v偏移丅L=self.m头皮*(v丅中间精简+v向垂直this-v向第一节*oA.pp毛发o.fp根延长);v偏移丅R=self.m头皮*(v丅中间精简-v向垂直this-v向第一节*oA.pp毛发o.fp根延长);
                else:
                    v偏移丅L=self.m头皮*(v丅中间精简+v向垂直this);v偏移丅R=self.m头皮*(v丅中间精简-v向垂直this);

                L新点ξ序v丅.append(v偏移丅L);L新点ξ序v丅.append(v偏移丅R);
                #print("LEN L毛序L点序cf3丅横点精简G",len(G.L毛序L点序cf3丅横点精简G));
                G.L毛序L点序cf3丅横点精简G[i毛序].append(v偏移丅L);G.L毛序L点序cf3丅横点精简G[i毛序].append(v偏移丅R);

                #----凷面点ξ与UV--------------------------------------------
                f长当前节Y偏移=(ii毛点数精简this-1-j毛点序精简)*f每节UV长;#如果是第1毛点 为 零#从上往下排UV
                fY上=f小+f长当前节Y偏移;fY下=fY上-f每节UV长;
                #----是第1个毛点  也是第一节-----------------------------------------
                if(j毛点序精简==0):
                    G.Li根点ξG.append(ξ点);L2Lξ点pin[0].append(ξ点);#0
                    L此毛面序i4面点ξ[i面序此毛].append(ξ点);#F0    0 [0]
                    ξ点+=1;#1
                    G.Li根点ξG.append(ξ点);L2Lξ点pin[0].append(ξ点);#1
                    L此毛面序i4面点ξ[i面序此毛].append(ξ点);#F0    1 [0,1]
                    ξ点+=1;#2
                    #----凷UV-----------------------------------------
                    L面序L4环uv序.setdefault(ξ面,[  [fX左,fY上],[fX左,fY下],[fX右,fY下],[fX右,fY上]  ]);
                #----其它节毛点-----------------------------------------
                else:
                    if(j毛点序精简==1):#第二节
                        L2Lξ点pin[1].append(ξ点);L2Lξ点pin[1].append(ξ点+1);
                    if(j毛点序精简<ii毛点数精简this-1):#不是最后1个毛点
                        if(oA.pp毛发o.bp顶点颜色):
                            G.CL毛序CLξ面色G[i毛序].append(ξ面);
                            #L毛序Li环ξG[i毛序].append(i环ξ);L毛序Li环ξG[i毛序].append(i环ξ+1);L毛序Li环ξG[i毛序].append(i环ξ+2);L毛序Li环ξG[i毛序].append(i环ξ+3);
                        i面序此毛+=1;ξ面+=1;i环ξ+=4;#F1
                        #print("j毛点序精简==",j毛点序精简);
                        L此毛面序i4面点ξ[i面序此毛].append(ξ点);#F1    2 [2]
                        L此毛面序i4面点ξ[i面序此毛-1].insert(-1,ξ点);#前1个面 F0    2 [0,2,1]
                        ξ点+=1;#3
                        L此毛面序i4面点ξ[i面序此毛].append(ξ点);#F1    3 [2,3]
                        L此毛面序i4面点ξ[i面序此毛-1].insert(-1,ξ点);#前1个面F0    3 [0,2,3,1]
                        ξ点+=1;#4

                        #----凷UV-----------------------------------------
                        L面序L4环uv序.setdefault(ξ面,[  [fX左,fY上],[fX左,fY下],[fX右,fY下],[fX右,fY上]  ]);

                    else:#是最后一节
                        G.Li尾点ξG.append(ξ点);#4
                        L此毛面序i4面点ξ[i面序此毛].insert(-1,ξ点);#最后1个面 F1    4 [2,4,3]
                        ξ点+=1;#5
                        G.Li尾点ξG.append(ξ点);#5
                        L此毛面序i4面点ξ[i面序此毛].insert(-1,ξ点);#最后1个面 F1    5 [2,4,5,3]
                        if(oA.pp毛发o.bp顶点颜色):
                            G.CL毛序CLξ面色G[i毛序].append(ξ面);
                            #L毛序Li环ξG[i毛序].append(i环ξ);L毛序Li环ξG[i毛序].append(i环ξ+1);L毛序Li环ξG[i毛序].append(i环ξ+2);L毛序Li环ξG[i毛序].append(i环ξ+3);

                        ξ点+=1;#6
                        ξ面+=1;i环ξ+=4;#F2    给下一条面


            #====2栋=======================================================
            elif(i此毛栋==2):
                if(j毛点序精简==0):#根点要移丅
                    v偏移丅L=self.m头皮*(v丅中间精简+v向垂直this-v向第一节*oA.pp毛发o.fp根延长);v偏移丅R=self.m头皮*(v丅中间精简-v向垂直this-v向第一节*oA.pp毛发o.fp根延长);
                    #---在第一节,计算脊梁是否要反方向--------------------------------------------
                    if(oA.pp毛发o.bp自动弓方向):
                        if(v向一条毛):
                            v向脊梁=vГ左右.cross(v此节乛后节点)*f毛宽this*oA.pp毛发o.fp弓因子;
                            f点积=round(v向一条毛.dot(v向脊梁),6);
                            if(f点积<0):#Λ大于90度
                                b脊梁反向=True;

                else:
                    v偏移丅L=self.m头皮*(v丅中间精简+v向垂直this);v偏移丅R=self.m头皮*(v丅中间精简-v向垂直this);
                v向脊梁=v此节乛后节点.cross(vГ左右)*f毛宽this*oA.pp毛发o.fp弓因子;
                
                if(oA.pp毛发o.bp自动弓方向):
                    if(b脊梁反向):
                        v向脊梁=-v向脊梁;
                v丅脊梁=(v偏移丅L+v偏移丅R)/2+v向脊梁;
                L新点ξ序v丅.append(v偏移丅L);L新点ξ序v丅.append(v丅脊梁);L新点ξ序v丅.append(v偏移丅R);
                G.L毛序L点序cf3丅横点精简G[i毛序].append(v偏移丅L);G.L毛序L点序cf3丅横点精简G[i毛序].append(v丅脊梁);  G.L毛序L点序cf3丅横点精简G[i毛序].append(v偏移丅R);
                #----凷面点ξ与UV-------------------------------------------
                f长当前节Y偏移=(ii毛点数精简this-1-j毛点序精简)*f每节UV长;#如果是第1毛点 为 零#从上往下排UV
                fY上=f小+f长当前节Y偏移;fY下=fY上-f每节UV长;
                if(j毛点序精简==0):#是第1个毛点  也是第一节
                    G.Li根点ξG.append(ξ点);L2Lξ点pin[0].append(ξ点);#0
                    L此毛面序i4面点ξ[i面序此毛].append(ξ点);#F0    0 [0]
                    ξ点+=1;#1
                    G.Li根点ξG.append(ξ点);L2Lξ点pin[0].append(ξ点);#1
                    L此毛面序i4面点ξ[i面序此毛].append(ξ点);#F0    1 [0,1]
                    if(oA.pp毛发o.bp顶点颜色):
                        G.CL毛序CLξ面色G[i毛序].append(ξ面);
                        #L毛序Li环ξG[i毛序].append(i环ξ);L毛序Li环ξG[i毛序].append(i环ξ+1);L毛序Li环ξG[i毛序].append(i环ξ+2);L毛序Li环ξG[i毛序].append(i环ξ+3);
                    #----凷第1个面的UV--与建面点ξ时顺序一致-----------------------------------------
                    L面序L4环uv序.setdefault(ξ面,[  [fX左,fY上],[fX左,fY下],[0.5,fY下],[0.5,fY上]  ]);#F0

                    i面序此毛+=1;ξ面+=1;i环ξ+=4;#F1
                    L此毛面序i4面点ξ[i面序此毛].append(ξ点);#F1    1 [1]
                    ξ点+=1;#2
                    G.Li根点ξG.append(ξ点);L2Lξ点pin[0].append(ξ点);#2
                    L此毛面序i4面点ξ[i面序此毛].append(ξ点);#F1    2 [1,2]

                    ξ点+=1;#3 给下1个面点
                    #----凷第二个面的UV-----------------------------------------
                    L面序L4环uv序.setdefault(ξ面,[  [0.5,fY下],[0.5,fY上],[fX右,fY上],[fX右,fY下]  ]);#F1

                else:
                    if(j毛点序精简==1):
                        L2Lξ点pin[1].append(ξ点);L2Lξ点pin[1].append(ξ点+1);L2Lξ点pin[1].append(ξ点+2);
                    if(j毛点序精简<ii毛点数精简this-1):#不是最后1个毛点
                        if(oA.pp毛发o.bp顶点颜色):
                            G.CL毛序CLξ面色G[i毛序].append(ξ面);
                            #L毛序Li环ξG[i毛序].append(i环ξ);L毛序Li环ξG[i毛序].append(i环ξ+1);L毛序Li环ξG[i毛序].append(i环ξ+2);L毛序Li环ξG[i毛序].append(i环ξ+3);
                        G.CL毛序CLξ面色G[i毛序].append(ξ面);
                        i面序此毛+=1;ξ面+=1;i环ξ+=4;#F2
                        L此毛面序i4面点ξ[i面序此毛].append(ξ点);#F2    3 [3]
                        L此毛面序i4面点ξ[i面序此毛-2].insert(-1,ξ点);#前二个面F0     3 [0,3,1]
                        ξ点+=1;#4
                        L此毛面序i4面点ξ[i面序此毛].append(ξ点);#F2    4 [3,4]
                        L此毛面序i4面点ξ[i面序此毛-1].insert(0,ξ点);#前1个面F1    4 [4,1,2]
                        if(oA.pp毛发o.bp顶点颜色):
                            G.CL毛序CLξ面色G[i毛序].append(ξ面);
                            #L毛序Li环ξG[i毛序].append(i环ξ);L毛序Li环ξG[i毛序].append(i环ξ+1);L毛序Li环ξG[i毛序].append(i环ξ+2);L毛序Li环ξG[i毛序].append(i环ξ+3);
                        G.CL毛序CLξ面色G[i毛序].append(ξ面);
                        #----凷第1个面的UV--与建面点ξ时顺序一致---------------------------------------------
                        L面序L4环uv序.setdefault(ξ面,[  [fX左,fY上],[fX左,fY下],[0.5,fY下],[0.5,fY上]  ]);#F2

                        i面序此毛+=1;ξ面+=1;i环ξ+=4;#F3
                        L此毛面序i4面点ξ[i面序此毛].append(ξ点);#F3    4 [4]
                        L此毛面序i4面点ξ[i面序此毛-3].insert(-1,ξ点);#前二个面F0     4 [0,3,4,1]
                        ξ点+=1;#5
                        L此毛面序i4面点ξ[i面序此毛].append(ξ点);#F3    5 [4,5]
                        L此毛面序i4面点ξ[i面序此毛-2].append(ξ点);#前1个面F1      5 [4,1,2,5]
                        ξ点+=1;#6
                        #----凷第二个面的UV-----------------------------------------
                        L面序L4环uv序.setdefault(ξ面,[  [0.5,fY下],[0.5,fY上],[fX右,fY上],[fX右,fY下]  ])#F1

                    else:#是最后1个毛点
                        G.Li尾点ξG.append(ξ点);#6
                        L此毛面序i4面点ξ[i面序此毛-1].insert(-1,ξ点);#最后二个面F2   6 [3,6,4]
                        ξ点+=1;#7
                        G.Li尾点ξG.append(ξ点);#7
                        L此毛面序i4面点ξ[i面序此毛].insert(0,ξ点);#最后1个面F3    7 [7,4,5]
                        L此毛面序i4面点ξ[i面序此毛-1].insert(-1,ξ点);#最后二个面F2   7 [3,6,7,4]
                        ξ点+=1;#8
                        G.Li尾点ξG.append(ξ点);#8
                        L此毛面序i4面点ξ[i面序此毛].append(ξ点);#最后1个面F3    8 [7,4,5,8]
                        if(oA.pp毛发o.bp顶点颜色):
                            G.CL毛序CLξ面色G[i毛序].append(ξ面);                                #L毛序Li环ξG[i毛序].append(i环ξ);L毛序Li环ξG[i毛序].append(i环ξ+1);L毛序Li环ξG[i毛序].append(i环ξ+2);L毛序Li环ξG[i毛序].append(i环ξ+3);
                        G.CL毛序CLξ面色G[i毛序].append(ξ面);
                        ξ点+=1;#9
                        ξ面+=1;i环ξ+=4;#F4    给下一条面

        #---------------------------------------------
        L面ξ序i4面点ξ序.extend(L此毛面序i4面点ξ);#面序[[2,3,4,6],[8,7,9,10],...]
        


#////end////end////end////end////end////end////end////end////









