

import bpy,sys
from bpy.props import *
from mathutils import*
from math import*

"HAIRBONE"

if("IMDJS_HairMesher.global_var" in sys.modules):
    G=sys.modules["IMDJS_HairMesher.global_var"];
else:
    import IMDJS_HairMesher.global_var as G;
    
class 卐GENERATE_BONES卐Operator(bpy.types.Operator):
    bl_idname = 'op.generate_bones';
    bl_label = 'generate_bones';
    bl_description = 'generate bones'
    #bl_options = {'REGISTER', 'UNDO', 'PRESET'    }#这个生成参数界面
    #---------------------------------------------
    bp骨骼:BoolProperty(name='generate bones ',description='generate bones ',default=False,subtype='NONE',update=None);

    def execute(self, context):
        oA=context.active_object;
        oA.pp毛发o.bp生成骨骼=True;
        bpy.ops.op.hair_mesher("INVOKE_DEFAULT");
        print("GEN BONE",oA.pp毛发o.bp生成骨骼);
        return {"FINISHED"    };


def oΔΔ增加骨架(wm,Co):
    #----建骨-----------------------------------------
    arm新= bpy.data.armatures.new("NEWBONE");
    if("HAIRBONE" in bpy.data.armatures):
        arm旧= bpy.data.armatures["HAIRBONE"];
        arm旧.user_clear();
        bpy.data.armatures.remove(arm旧);
        print("REMOVE BONE",);

    #----新建骨架-------------------------------------------
    if("HAIRBONE" in bpy.data.objects):
        o骨= bpy.data.objects["HAIRBONE"];
        o骨.data=arm新;

    else:
        o骨= bpy.data.objects.new("HAIRBONE",arm新);
        bpy.context.scene.collection.objects.link(o骨);

    o骨.data.name="HAIRBONE";
        #bpy.data.meshes.remove(arm新);
    if(Co.active!=o骨):
        Co.active=o骨;
    return o骨;


#==============================================================
"""
def ΔΔ增加骨骼(arm新):
    Ceb=arm新.edit_bones;
    #----EB要在编辑模式下-----------------------------------------
    if(bpy.context.active_object.mode!="EDIT"):
        bpy.ops.object.mode_set(mode="EDIT");
        print("Ceb==",Ceb);
        eb=Ceb.new("0");eb.head=(1,1,1);#必须要二值才能实体化,否则会消失
        eb=Ceb.new("1");eb.head=(2,1,1);
"""
#///////////////////////////////
class 卐绑定权卐Operator(bpy.types.Operator):
    bl_idname = 'op.hair_mesher("INVOKE_DEFAULT")_add_weight';
    bl_label = '';
    bl_description = 'hair_mesher_add_weight'
    iip骨数每点绑定:IntProperty();

    @classmethod
    def poll(self,context):
        return context.active_object.pp毛发o.bp生成骨骼;

    #==============================================================
    def execute(self, context):
        #from .IMDJS_HairMesher import G.L毛序L点序cf3丅横点精简G,G.L条序L骨序Ds骨名v中丅精简G,G.Li根点ξG, G.Li尾点ξG;
        G.Li根点ξG=set(G.Li根点ξG);G.Li尾点ξG=set(G.Li尾点ξG);
        oA=context.active_object;

        Cvg=oA.vertex_groups;#Cmv=o新网格.data.vertices;
        #print("Cvg",o新网格,Cvg);
        #L网点序L绑定骨数序Ds骨名f最近=[];#[    [{s骨名:f距离    },{s骨名:f距离    }],[{s骨名:f距离    },{s骨名:f距离    }],...     ]
        Lf累距网ξ序=[];Ls所有骨名=[];
        #L点ξ序L绑定骨数序Ds骨名f骨权=[];#[    [{s骨名:f骨权    },{s骨名:f骨权    }],[{s骨名:f骨权    },{s骨名:f骨权    }],...]
        ξ点真=-1;
        for i条序,L点序v丅精简 in enumerate(G.L毛序L点序cf3丅横点精简G):
            L骨序Ds骨名v丅精简=G.L条序L骨序Ds骨名v中丅精简G[i条序];#[[{s骨名:v丅精简    },{s骨名:v丅精简    }],[{s骨名:v丅精简    },{s骨名:v丅精简    }],...]
            #print("LDs==",L骨序Ds骨名v丅精简);#√
            ii骨数这条=len(L骨序Ds骨名v丅精简);
            #ii点数这条=len(L点序v丅精简);
            for i点序,v丅精简 in enumerate(L点序v丅精简):#迭代这条边点
                ξ点真+=1;
                #print("ξ点真",i条序,i点序,ξ点真);#continue;

                L绑定骨数序Li骨序f最近此网点绑定骨数个骨=[[] for i in range(self.iip骨数每点绑定)];#[[],[],...]
                #L网点序L绑定骨数序Ds骨名f最近.append([]);#[[],]
                #L点ξ序L绑定骨数序Ds骨名f骨权.append([]);#[[],]
                Lf累距网ξ序.append(0);#[0,]
                f距离网骨上次最短=1000000.0;#n个最短
                iip骨数每点绑定=self.iip骨数每点绑定;
                if(iip骨数每点绑定>ii骨数这条):
                    iip骨数每点绑定=ii骨数这条;
                i绑定点=iip骨数每点绑定;

                Lf反权此网点=[-1 for i in range(iip骨数每点绑定)];
                f总反权此网点=0.0;
                #---迭代这条骨点---找齐1个网点到骨丅距离最短几个点----------------------------------------
                for i骨序,Ds骨名v丅精简 in enumerate(L骨序Ds骨名v丅精简):
                    #print("ORDER",i骨序);#√

                    f距离两点Now=(list(Ds骨名v丅精简.values())[0]-v丅精简).length;
                    if(f距离两点Now==0):#//距离不能为0
                        f距离两点Now=0.00001;

                    #----先凷  前 i绑定骨数_  个M点--------------------------------------------
                    if(i绑定点!=0):
                        L绑定骨数序Li骨序f最近此网点绑定骨数个骨[i骨序]=[i骨序,f距离两点Now];#i骨序<iip骨数每点绑定
                        i绑定点-=1;#print("i绑定点",i绑定点,i骨序);
                        continue;

                    #----找到比上次更短的,像个漏斗每进一次门就小一点---------------------------------
                    #[[i骨序,6.0],[i骨序,7.0],[i骨序,4.0],[i骨序,3.0]]↓ L绑定骨数序Li骨序f最近此网点绑定骨数个骨
                    #[[i骨序,6.0],[i骨序,2.0],[i骨序,4.0],[i骨序,3.0]]↓ L绑定骨数序Li骨序f最self.短距离此网点绑定骨数个骨
                    # 不断凷更短的点ξM
                    #☐☐☐☐☐☐●发点●发点☐☐☐☐☐☐
                    #☐☐☐☐☐┆┃┊┆┃┊☐☐☐☐☐☐
                    #☐☐☐☐☐│┃┇☐┃┇☐☐☐☐☐☐
                    #☐☐☐☐☐↓︱↓☐︱☐☐☐☐☐
                    #☐☐☐☐■━ ■━  ■━  ■☐☐☐☐
                    #☐☐☐☐☐☐☐☐    骨☐   骨☐☐☐☐
                    #----小于f距离网骨上次最短-----------------------------------------
                    if(f距离两点Now<f距离网骨上次最短 ):#第一次必须true
                        f距离网骨上次最短=f距离两点Now;
                       #----先找到数组内最大元素,然后---------------------------------------------
                        f数组内最大距离=0.0;i组ξ最后=-1;
                        for i绑定骨数第几个 in range(iip骨数每点绑定):
                            if(f数组内最大距离<=4[i绑定骨数第几个][1]):
                                f数组内最大距离=L绑定骨数序Li骨序f最近此网点绑定骨数个骨[i绑定骨数第几个][1];
                                i组ξ最后=i绑定骨数第几个;

                        #----凷f距离两点Now给它-----------------------------------------
                        if(f距离两点Now<f数组内最大距离):#把当前组内最大元素替换
                            L绑定骨数序Li骨序f最近此网点绑定骨数个骨[i组ξ最后]=[i骨序,f距离两点Now];#[[i骨序,f距离],[i骨序,f距离],...]
                    #print("L绑定骨数序==",L绑定骨数序Li骨序f最近此网点绑定骨数个骨);


                #====数值凷=================================================
                for i绑定骨数第几个 in range(iip骨数每点绑定):
                    L=L绑定骨数序Li骨序f最近此网点绑定骨数个骨[i绑定骨数第几个];
                    f距离两点Now=L[1];
                    Lf累距网ξ序[ξ点真]+=f距离两点Now;#积累

                #----计算权-每条面计算一次---------------------------------------------
                for i绑定骨数第几个 in range(iip骨数每点绑定):
                    L=L绑定骨数序Li骨序f最近此网点绑定骨数个骨[i绑定骨数第几个];
                    f距离两点Now=L[1];
                    Lf反权此网点[i绑定骨数第几个]=1/(f距离两点Now/Lf累距网ξ序[ξ点真]);
                    f总反权此网点+=Lf反权此网点[i绑定骨数第几个];

                for i绑定骨数第几个 in range(iip骨数每点绑定):
                    L=L绑定骨数序Li骨序f最近此网点绑定骨数个骨[i绑定骨数第几个];
                    i骨序This=L[0];    #L点ξ序L绑定骨数序Ds骨名f骨权[ξ点真].append(list(L骨序Ds骨名v丅精简[i骨序This].keys())[0]:Lf反权此网点[i绑定骨数第几个]/f总反权此网点);
                    #print("THIS BONE",i骨序This);
                    f权=Lf反权此网点[i绑定骨数第几个]/f总反权此网点;

                    #----绑定顶点权------------------------------------------
                    for s骨名,v丅精简 in L骨序Ds骨名v丅精简[i骨序This].items():#这组所有骨名
                        if(s骨名 not in Ls所有骨名):Ls所有骨名.append(s骨名);

                        #print("bone name=",s骨名);
                        if(s骨名 not in Cvg.keys() ):
                            vg新=Cvg.new(name=s骨名);
                            if(ξ点真 in G.Li根点ξG):
                                if(i骨序This==0):
                                    vg新.add([ξ点真], 1.0, "ADD");    #print("HNs骨名",s骨名,ξ点真,f权);
                            elif(ξ点真 in G.Li尾点ξG):
                                if(i骨序This==ii骨数这条-1):#是最后1个骨
                                    vg新.add([ξ点真], 1.0, "ADD"); #print("TNs骨名",s骨名,ξ点真,f权);
                            else:
                                vg新.add([ξ点真], f权, "ADD");#print("s骨名",s骨名,ξ点真,f权);
                            #print("ADD",vg新.name);
                        else:
                            vg旧=Cvg[s骨名];
                            #print("vg",vg旧);
                            #if(f权!=vg旧.weight(index=ξ点真)):
                            if(ξ点真 in G.Li根点ξG):
                                if(i骨序This==0):
                                    vg旧.add([ξ点真], 1.0, "REPLACE");#print("Hs骨名",s骨名,ξ点真,f权);
                            elif(ξ点真 in G.Li尾点ξG):
                                if(i骨序This==ii骨数这条-1):#是最后1个骨
                                    vg旧.add([ξ点真], 1.0, "REPLACE");#print("Ts骨名",s骨名,ξ点真,f权);
                            else:
                                vg旧.add([ξ点真], f权, "REPLACE");#print("s骨名",s骨名,ξ点真,f权);

                        #print("s骨名",s骨名,ξ点真,f权);
        #----清除多余群组-----------------------------------------
        for s组名,vg in Cvg.items():
            if(s组名 not in Ls所有骨名):
                Cvg.remove(vg);
                #print("REMOVE",vg.name);

        #print("Cvg++",Cvg.keys(),G.L条序L骨序Ds骨名v中丅精简G);

        return {"FINISHED"    };


#////end////end////end////end////end////end////end////end////
















