

import bpy,sys
from bpy.props import *
from mathutils import*

from .HairMesher_other import*

if("IMDJS_HairMesher.global_var" in sys.modules):
    G=sys.modules["IMDJS_HairMesher.global_var"];
else:
    import IMDJS_HairMesher.global_var as G;



if("PYLIB.global_var_LIB" in sys.modules):
    LG = sys.modules["PYLIB.global_var_LIB"];
else:
    try:
        exec("import "+G.文件夹此HairMesher+".PYLIB_"+G.文件夹此HairMesher+".global_var_LIB as LG");
    except:
        import PYLIB.global_var_LIB as LG;         
        
#------------------------------
if("PYLIB.PYLIB_main" not in sys.modules):
    try:
        from PYLIB.PYLIB_main import*;
    except:
        if(G.文件夹此HairMesher+".PYLIB_"+G.文件夹此HairMesher+".PYLIB_"+G.文件夹此HairMesher not in sys.modules):
            exec("from  "+".PYLIB_"+G.文件夹此HairMesher+".PYLIB_"+G.文件夹此HairMesher+"  import*");
    
class 卐select_near_hair卐Operator(bpy.types.Operator):
    bl_idname = 'op.select_near_hair';
    bl_label = 'select near hairs';
    bl_description = 'select near hairs'        
        
    ip是毛or是点or最长毛:IntProperty(name='',description='',default=0,min=0,max=10000,step=1,subtype='NONE',update=None);
    @classmethod
    def poll(self,context):
        try:
            return  context.active_object.particle_systems ;
        except:
            return False;
        
        return False;
         
    def execute(self, context):
        #----总载体-----------------------------------------
        if(G.dll==None):
            if(platform.system()=="Windows"):
                G.dll=dll载入dll(G,"dll",dllpathB,dllpath64,dllpath32);
        #---------------------------------------------
        G.oA=context.active_object;G.o头皮=None;
        if(0<G.oA.particle_systems.__len__()):
            ParticleSystem=G.oA.particle_systems.active;
            if(ParticleSystem==None):
                self.report({"ERROR"},"no hair or hair is hide!!!");#"INFO" "ERROR" "DEBUG" "WARNING"
                return {"FINISHED"};
            
            if(context.active_object.mode!="PARTICLE_EDIT"):
                bpy.ops.object.mode_set(mode="PARTICLE_EDIT");
            bpy.ops.particle.select_all(action='DESELECT');
            if(self.ip是毛or是点or最长毛==0):
                G.dll.Δ选择相近毛(c_void_p(G.oA.as_pointer()),c_void_p(ParticleSystem.as_pointer()),c_float(G.oA.pp毛发o.fp删除距离2fac));
            elif(self.ip是毛or是点or最长毛==1):
                G.dll.Δ选择相近点(c_void_p(ParticleSystem.as_pointer()),False);
            elif(self.ip是毛or是点or最长毛==2):
                G.dll.Δ选择相近点(c_void_p(ParticleSystem.as_pointer()),True);          
            # ParticleSystem.update_tag(refresh={'DATA'});
            G.oA.update_tag(refresh={"OBJECT",'DATA'});
            bpy.ops.object.mode_set(mode="OBJECT");bpy.ops.object.mode_set(mode="PARTICLE_EDIT");#刷新状态
            
        else:
            self.report({"ERROR"},"no hair or hair is hide!!!");#"INFO" "ERROR" "DEBUG" "WARNING"
            return {"FINISHED"};            
  
        return {"FINISHED"};
        
#==================================================
class 卐HairMesher卐Operator(bpy.types.Operator):
    bl_idname = 'op.hair_mesher';
    bl_label = 'IMDJS_HairMesher';
    bl_description = 'IMDJS_HairMesher'
    #bl_options = {'REGISTER', 'UNDO', 'PRESET'    }#这个生成参数界面

    #☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
    #☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
    #☐☐☐☐☐☐☐☐●key.co☐☐☐☐☐☐
    #☐☐☐☐☐☐☐☐↖☐☐☐☐☐☐☐☐
    #☐☐☐☐☐☐☐│☐☐\☐☐☐☐☐☐☐
    #☐☐☐☐┈N  ┆☐☐☐☐\☐☐☐☐☐☐
    #☐☐☐☐☐┅┈☐☐☐☐☐●☐☐☐☐☐
    #☐☐☐☐☐☐☐┅┈☐☐☐☐┅┈☐☐☐

    Co=None;  Cmesh=None;mod毛=None;b是新建毛发=False;
    # bp要对齐法线:BoolProperty(name='',description='',default=False);
    #Liξ毛发采样=[];
    #---------------------------------------------
    @classmethod
    def poll(self,context):
        return context.active_object;
        try:
            return  context.active_object.particle_systems ;
        except:
            return False;
    def invoke(self, context, event):  
        #----总载体--------------------------------------------------
        if(G.dll==None):
            if(platform.system()=="Windows"):
                G.dll=dll载入dll(G,"dll",dllpathB,dllpath64,dllpath32);        
        #----第一次------------------------------------------
        scene=context.scene;
        G.oA=context.active_object; self.Co=bpy.data.objects;self.Cmesh=bpy.data.meshes;
        if(scene.tool_settings.particle_edit.type!="PARTICLES"):
            scene.tool_settings.particle_edit.type="PARTICLES";
        if(scene.tool_settings.particle_edit.display_step<4):
            scene.tool_settings.particle_edit.display_step=4;
        # if(0<G.oA.particle_systems.__len__()):
           # if(G.oA.pp毛发o.bpINIT==False):
            # Δ复制propG属性(G.oA.pp毛发o,G.oA.pp毛发o);#●第一次
        if(G.i版本D!=G.oA.pp毛发o.ip版本):    
            Δ复制propG属性(G.oA.pp毛发o,G.oA.pp毛发o);
        self.b是新建毛发=False;
        #----初始化--------------------------
        # if(LG.CL条序L段序L4f2乛画G==[]):
            # LG.CL条序L段序L4f2乛画G=(c_float*2*4*20)();
            # LG.CL条序L段序L2f2一一画G=(c_float*2*2*50)();
        if(LG.b停止仌G==True):LG.b停止仌G=False;
        return self.execute(context);
        
    def Δ恢复(self,oA,oHair):
        LG.b停止仌G=True;
        #if(oA.pp毛发o.bp骨节数变了==True):oA.pp毛发o.bp骨节数变了=False;        
        if(oA.pp毛发o.bp毛发数变了==True):oA.pp毛发o.bp毛发数变了=False;
        if(oA.pp毛发o.bp面点数变了==True):oA.pp毛发o.bp面点数变了=False;   
        if(oA.pp毛发o.bp毛seg数变了==True):oA.pp毛发o.bp毛seg数变了=False;           
        if(oA.pp毛发o.bp1要updateO==True):oA.pp毛发o.bp1要updateO=False;      
        if(oA.pp毛发o.bptwisted==True):oA.pp毛发o.bptwisted=False;
        if(oA.pp毛发o.bpUV变了==True):oA.pp毛发o.bpUV变了=False;        
        if(oA.pp毛发o.bp更新权==True):oA.pp毛发o.bp更新权=False;       
        if(oA.pp毛发o.bp不同激活毛发==True):oA.pp毛发o.bp不同激活毛发=False;      
        if(oA.pp毛发o.bp更新mat==True):oA.pp毛发o.bp更新mat=False;
        if(oHair):
            if(oHair.pp毛发o.bp已经生成o==False):
                oHair.pp毛发o.bp已经生成o=True;
            
        if(G.o头皮旧!=G.o头皮):
            G.o头皮旧=G.o头皮;
            oA.pp毛发o.bp换了头皮=True;
        else:
            if(oA.pp毛发o.bp换了头皮==True):oA.pp毛发o.bp换了头皮=False;
        LG.b停止仌G=False;

    #==============================================================
    def execute(self, context):
        #Δ清空();
        time1 = time.time();
        #print("bp毛发数变了",G.oA.pp毛发o.bp毛发数变了);
        Co视=context.view_layer.objects;
        # Co场景=context.collection.objects;
        Co场景=context.view_layer.layer_collection.collection.objects;
        
        G.oA=context.active_object;G.o头皮=None;
        if(G.oA.pp毛发o.bp实时==False):
            #----恢复-------------------------------------------
            self.Δ恢复(G.oA,None);
            return {"FINISHED"};
        #---------------------------------------------
        if(0<G.oA.particle_systems.__len__()):#选中的是头皮
            G.o头皮=G.oA;
            s网名=s同名改(G.o头皮.name+"_HAIR",bpy.data.meshes.keys());
            G.mesh新= self.Cmesh.new(s网名);#有可能是.001
            G.oHair= self.Co.new(G.o头皮.name+"_HAIR",G.mesh新);Co场景.link(G.oHair);#有可能是.001#print("is hair skin",G.o头皮,G.oA.particle_systems);
            # Co视.active=G.o头皮;G.oHair.select_set(False);
            ParticleSystem=G.o头皮.particle_systems.active;
            Δ复制propG属性(G.o头皮.pp毛发o,G.oHair.pp毛发o);#●第一次把头皮属性 转给 头发
            self.b是新建毛发=True;
        else:#生成了头发
            G.oHair=G.oA;
            if(G.oHair.pp毛发o.sp头皮 in self.Co):
                #print("havs skin",);
                G.o头皮=self.Co[G.oHair.pp毛发o.sp头皮];
                if(G.o头皮.hide_viewport==True):
                   G.o头皮.hide_viewport=False;  
            print("o头皮==",G.o头皮,G.oHair,G.oHair.pp毛发o.sp头皮, self.Co.keys);
            ParticleSystem=G.o头皮.particle_systems[G.oHair.pp毛发o.sp粒子];#print("A par==",G.o头皮.particle_systems.active,ParticleSystem);
            if(G.o头皮.particle_systems.active!=ParticleSystem):
                for i,ps in enumerate(G.o头皮.particle_systems):
                    if(ps==ParticleSystem and i!=G.o头皮.particle_systems.active_index):
                        G.o头皮.particle_systems.active_index=i;break;
                G.o头皮.particle_systems.active=ParticleSystem;
            
        if(ParticleSystem==None):
            self.report({"ERROR"},"no hair or hair is hide!!!");#"INFO" "ERROR" "DEBUG" "WARNING"
            return {"FINISHED"};
        #----MOD--------------------------
        if(self.mod毛==None):
            s毛名=ParticleSystem.name;self.mod毛=mod罒(s毛名,"PARTICLE_SYSTEM",G.o头皮);
            if(self.mod毛.show_viewport==False):
                self.mod毛.show_viewport=True;
        print("self.mod毛==",self.mod毛);
        
        #----凷--------------------------
        ps=ParticleSystem.settings;
        #if(ps.draw_step<4):ps.draw_step=4;
        G.cvpPS=c_void_p(ParticleSystem.as_pointer());cvpO头皮=c_void_p(G.o头皮.as_pointer());cvpOhair=c_void_p(G.oHair.as_pointer());cvpC=c_void_p(context.as_pointer());
        
        if(G.dll.iDiffScene(cvpC)):
            print("~~CHANGE SCENE==",G.dll.iDiffScene(cvpC));
            G.dll.Δ灬G();
            Δ凷V发(G.cvpPS,context);
            # return {"FINISHED"};#■■++
            self.mod毛=None;
            G.oHair.pp毛发o.bp1要updateO=True;
        #----凷粒子系统--------------------------
        elif(G.dll.bΔ空头发G(G.cvpPS) or G.oHair.pp毛发o.bp1要updateO or G.oHair.pp毛发o.bp毛发数变了):
            Δ凷V发(G.cvpPS,context);
        

        G.dll.Δinit状态发0(cvpOhair, G.cvpPS);
        # return {"FINISHED"};#■■++
        
        ip毛发数now=G.dll.iΔ多少根毛卩(G.cvpPS,G.oHair.pp毛发o.bp要子级 ,cvpC);
        if(G.oHair.pp毛发o.ip毛发数!=ip毛发数now):
            G.oHair.pp毛发o.ip毛发数=ip毛发数now;#●●检测了bl版本
            if(G.oHair.pp毛发o.bp毛发数变了==False):G.oHair.pp毛发o.bp毛发数变了=True;
        print("Par  NUM==",G.oHair.pp毛发o.ip毛发数,ps,ps.type,G.oHair.pp毛发o.bp毛发数变了);#√
        if(ps.type!="HAIR"):
            self.report({"ERROR"},"this not hair particle");#"INFO" "ERROR" "DEBUG" "WARNING"
            return{"FINISHED"};
        if(G.oHair.pp毛发o.ip毛发数==-1):
            self.report({"ERROR"},"the test version anly availabe before version 2.78");#"INFO" "ERROR" "DEBUG" "WARNING"
            return{"FINISHED"};
        #----根据选择网点数判断不同头皮------------------------------------
        Lmv头皮=None;
        if(G.o头皮):
            Lmv头皮=G.o头皮.data.vertices;i网点数=len(Lmv头皮);
            if(Lmv头皮.__len__()!=G.i网点数thisG):
                G.oHair.pp毛发o.bp不同激活毛发=True;
                G.i网点数thisG=Lmv头皮.__len__();
            
        
        b空=G.dll.bΔV毛序V检测ξ面lastG是空0(G.cvpPS);
        #print("B1==%d;B2==%d;Bpar==%d;Bch==%d"%(b空,b空2, 0<G.o头皮.particle_systems.__len__(),not G.oHair.pp毛发o.bp不同激活毛发));
        if(b空):#第一次
            print("CHANGE== ",b空,0<G.o头皮.particle_systems.__len__());
            if(G.oHair.pp毛发o.bp毛发数变了==False):G.oHair.pp毛发o.bp毛发数变了=True;
        #----清空---------------------------------------------
        if(G.oHair.pp毛发o.bp毛发数变了 or G.oHair.pp毛发o.bp毛seg数变了 or G.oHair.pp毛发o.bp1要updateO or G.oHair.pp毛发o.bp更新权 or G.oHair.pp毛发o.bp不同激活毛发 ):
            G.dll.iΔ毛点数Max(cvpOhair,G.cvpPS,G.oHair.pp毛发o.bp已经生成o==False);

            ΔΔ数据变了(G.cvpPS,G.oHair.pp毛发o,context);

        if(G.oHair.pp毛发o.bp要子级):
            self.m头皮=Matrix();#●●如果是子级,不用乘这个,就是Π的
        else:
            self.m头皮=G.o头皮.matrix_world;#vX方向=v巜m(mA,"X");#让物体X轴为假设面朝向
        scale=sum(G.o头皮.dimensions)/3;
        #if(platform.system()=="Windows"):
        Cmp=G.o头皮.data.polygons;#Cmv=G.o头皮.data.vertices;

        #必须重载数据●●每个operator,只能读取一次,第二次读取毛点丅会全为0 ???
        #print("CHANGE  H==%d;W==%d;U==%d;CH==%d;T==%d;M==%d"%(G.oHair.pp毛发o.bp毛发数变了,G.oHair.pp毛发o.bp更新权,G.oHair.pp毛发o.bp1要updateO,G.oHair.pp毛发o.bp不同激活毛发,G.oHair.pp毛发o.bptwisted,G.oHair.pp毛发o.bp更新mat));
        print("time0---->: %.3f" % (time.time() - time1));
        #---------------------------------------------
        #☐☐0☐☐☐    2☐☐☐  4 ☐☐☐☐☐☐☐☐☐☐
        #☐☐●━━→●━━→● 网点☐☐☐☐☐☐☐☐☐
        #☐☐☐☐☐☐┃☐☐☐┃ ☐☐☐☐☐☐☐☐☐☐
        #☐☐○0  ☐☐○1   ☐☐○ 毛点☐☐☐☐☐☐☐☐
        #☐☐☐☐☐☐↓☐☐☐↓ ☐☐☐☐☐☐☐☐☐☐
        #☐☐●←━━●←━━● 网点☐☐☐☐☐☐☐☐☐☐
        #☐☐1☐☐☐   3☐ ☐☐  5 ☐☐☐☐☐☐☐☐☐☐☐☐
        #☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
        #print("len==",len(ParticleSystem.particles));
        #☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
        #☐☐0☐━→   3☐━→   6 网点☐☐☐☐☐☐☐☐☐
        #☐☐☐0  ☐☐┃2   ☐☐┃☐☐☐☐☐☐☐☐☐☐☐
        #☐☐☐☐☐☐↓☐☐☐↓☐☐☐☐☐☐☐☐☐☐☐
        #☐☐1←━━   4←━━  7  网点☐☐☐☐☐☐☐☐☐☐
        #☐☐┃1  ☐☐┃3   ☐☐┃☐☐☐☐☐☐☐☐☐☐
        #☐☐↓☐☐☐↓☐☐☐↓☐☐☐☐☐☐☐☐☐☐☐
        #☐☐2━━→   5━━→   8  网点☐☐☐☐☐☐☐☐

        print("IS CHANGE??==",G.oHair.pp毛发o.bp毛发数变了,G.oHair.pp毛发o.bp1要updateO,G.oHair.pp毛发o.bptwisted ,G.oHair.pp毛发o.bp不同激活毛发);
        print("IS TRI??==",G.oHair.pp毛发o.bp三角形,G.oHair.pp毛发o.bp随机方向);
        #print("==",G.oHair.pp毛发o.bp毛发数变了,len());
        #----凷   V毛序Vv毛点丅ΠG-----------------------------------------
        if(G.oHair.pp毛发o.bp毛发数变了 or G.oHair.pp毛发o.bp1要updateO or G.oHair.pp毛发o.bp不同激活毛发):
            b没子=False;#f最长毛=-1.0;
            #print("G.oHair HAIR NUM",G.oHair.pp毛发o.ip毛发数);
            if(platform.system()=="Windows"):
                G.dll.fΔ创建粒子毛发1.restype=c_float;
                print("==",G.i1毛点数maxG);
                G.dll.fΔ创建粒子毛发1(cvpOhair,G.cvpPS);#V毛序Vv毛点丅ΠG ■,V毛序f毛长G ■;
                # G.oHair.pp毛发o.fp最长毛=G.dll.fΔ创建粒子毛发1(G.cvpPS);
                print("PARTICLE +++>",);

                print("time1---->: %.3f" % (time.time() - time1));
        #print("Lf hair lengt");
        #print("i max C==",G.oHair.pp毛发o.iip毛点数Max);

        #----cp采样毛序Cv丅OrigΠ-----------------------------------------
        #print("fp扭曲距离阈值==",fp扭曲距离阈值);
        #Δ初始化骨骼(G.oHair.pp毛发o.ip毛发数);
        print("time2---->: %.3f" % (time.time() - time1));
        #====建毛发面=================================================
        G.dll.Δ毛发点数面数2(cvpO头皮,cvpOhair,G.cvpPS,G.oHair.pp毛发o.sp权seg !="");
        print("time4---->: %.3f" % (time.time() - time1));
        #G.dll=dll卸载dll(G,"dll"); return {"FINISHED"};#■■
        #LG.LL2cf3一一序G=(c_float*3*2*G.oHair.pp毛发o.iip毛点数Max)();
        #print("G.Lcf3G==",[0][0][0],[0][0][1],[0][0][2]);
        #print("len(G.CL面序L4环uv序G_)",len(G.CL面序L4环uv序G_));
        i毛发数5=G.oHair.pp毛发o.ip毛发数*5;Lci尾点ξG_=(c_int*i毛发数5)(*[-1]*i毛发数5);Lci根点ξG_=(c_int*i毛发数5)(*[-1]*i毛发数5);           
        Lci根点ξG_=(c_int*i毛发数5)(*[-1]*i毛发数5);G.CL2CLξ点pinG_=(c_int*i毛发数5*2)(*[Lci根点ξG_]*2);G.p2L2Lcξ点pin_=Ψ2ci(G.CL2CLξ点pinG_);
        
        #----第一次-----------------------------------------
        if(G.oHair.pp毛发o.bp毛发数变了 or G.oHair.pp毛发o.bp1要updateO or G.oHair.pp毛发o.bptwisted or G.oHair.pp毛发o.bp不同激活毛发 ):#or  G.oHair.pp毛发o.bptwisted 
            G.dll.Δ初始化V毛序V检测ξ面lastG3(G.oHair.pp毛发o.ip毛发数,G.oHair.pp毛发o.iip毛点数Max,G.cvpPS);
            print("LAST1==",scale/5);
            if(G.oHair.pp毛发o.bp随机方向==False):
                G.dll.Δ毛得最近头皮面ξlast3_0(cvpO头皮,G.cvpPS,G.i忽略面数G,G.oHair.pp毛发o.ip毛发数,G.oHair.pp毛发o.iip毛点数Max,c_float(scale/5),G.o头皮旧!=G.o头皮);
                #G.oHair.pp毛发o.bp已经运行last函数=True;

        print("time3---->: %.3f" % (time.time() - time1));

        #return {"FINISHED"    };#p2L毛序Lcξ面最近头皮序G=Ψ2ci(G.L毛序Lcξ面最近头皮序G);

        #====建点面=============================================
        print("time4.2---->: %.3f" % (time.time() - time1));print("==",G.oHair.pp毛发o.bp毛发数变了);
        G.dll.ΔΔ毛发构建点面4(cvpO头皮,cvpOhair,G.cvpPS,cvpC,0<G.o头皮.particle_systems.__len__(),G.bp要对齐法线G,
        
        #----pin权-----------------------------------------
        Lci根点ξG_,Lci尾点ξG_,byref(G.p2L2Lcξ点pin_),
        #----造面所需-----------------------------------------
        byref(G.ci实际点数G_),byref(G.ci实际边数G_),byref(G.ci实际环数G_),byref(G.ci实际面数G_),
        #LG.LL2cf3一一序G
        #----画画--------------------------
        #LG.CL条序L段序L4f2乛画G,LG.CL条序L段序L2f2一一画G
        );
        # return {"FINISHED"};#■■
        #print("ciP F NUM  AFTER==",G.ci实际点数G_.value,G.ci实际面数G_.value);
        print("time5---->: %.3f" % (time.time() - time1));
        #画3dLIB(self);#print("LG.LL2cf3一一序G",LG.LL2cf3一一序G);
        #G.dll=dll卸载dll(G,"dll"); return {"FINISHED"};#■■
        # bpy.ops.object.mode_set(mode="OBJECT");#骨转成OBJECT模式
        
        #self.Δ恢复(G.oHair,None);G.dll=dll卸载dll(G,"dll"); return {"FINISHED"};#■■

        #====建面======================================================
        #----第一次,把旧的改名------------------------------------------
        if(self.b是新建毛发):
            #----新建面-------------------------------------------
            十点线面卩(G.mesh新,G.ci实际点数G_.value,G.ci实际边数G_.value,G.ci实际面数G_.value,G.ci实际环数G_.value); 
            G.dll.重属性网(c_void_p(G.mesh新.as_pointer()));
            #if(G.o头皮.name+"_HAIR" in bpy.data.meshes.keys()):
            #print("NEW MESH==",G.mesh新);
            #----新建物---------------------------------------------
            #G.mesh新=bpy.data.meshes[s网名];
            #G.oHair.data=G.mesh新;
            print("NEW G.oHair==",G.oHair,G.oHair.data.name);
            G.oHair.data.name=G.oHair.name;
            if(Co视.active!=G.oHair):Co视.active=G.oHair;
            G.oHair.select_set(True);bpy.ops.object.shade_smooth();
            #Δ复制propG属性(G.o头皮.pp毛发o,G.o头皮.pp毛发o);
        #----自身-----------------------------------------
        else:
            G.oHair=G.oHair;
            G.mesh新=G.oHair.data;
            if(G.s上次激活毛发G!=G.oHair.name):
                G.s上次激活毛发G=G.oHair.name;

            #G.oHair.pp毛发o.bp毛发数变了=True;#●●如果不清空 uv会出错
            #----脏-------------------------------------------
            #print("▲==",G.oHair.pp毛发o.bp面点数变了);
            if(G.oHair.pp毛发o.bp面点数变了):
                #----新建面--------------------------------------------
                十点线面卩(G.mesh新,G.ci实际点数G_.value,G.ci实际边数G_.value,G.ci实际面数G_.value,G.ci实际环数G_.value);
                G.dll.重属性网(c_void_p(G.mesh新.as_pointer()));
                if(Co视.active!=G.oHair):Co视.active=G.oHair;
                bpy.ops.object.shade_smooth();
        #----材质--------------------------
        if((G.oHair.pp毛发o.bp更新mat) and G.oHair.pp毛发o.bp忽略材质==False):
            bpy.ops.op.import_material(ip材质ξ=G.oHair.pp毛发o.ip材质ξ);
        if(G.oHair.active_material):
            if(G.oHair.pp毛发o.sp材质!=G.oHair.active_material.name):
                G.oHair.pp毛发o.sp材质=G.oHair.active_material.name;
        #print("MAT==",G.oHair.pp毛发o.sp材质,G.oHair.active_material.name);

        #---------------------------------------------
        if(G.oHair.hide_viewport==True):G.oHair.hide_viewport=False;
        if(G.oHair.hide_select==True):G.oHair.hide_select=False;
        if(G.oHair.hide_render==True):G.oHair.hide_render=False;
        G.oHair.location=(0.0,0.0,0.0);G.oHair.rotation_euler=(0.0,0.0,0.0);
        cvpOhair=c_void_p(G.oHair.as_pointer());
        #return ;
        #print("MAT==",G.oHair.pp毛发o.bp更新mat);
        #----如果是头皮,交换激活物与数据-------------------------------------------
        if(self.b是新建毛发):
            G.o头皮.select_set(False);G.oHair.select_set(True);Co视.active=G.oHair;
            #print("G.o头皮.pp毛发o",G.o头皮.pp毛发o.keys());
            G.oHair.pp毛发o.sp头皮=G.o头皮.name;#;
            G.oHair.pp毛发o.sp粒子=G.o头皮.particle_systems.active.name;
            if(G.o头皮.pp毛发o.sp材质):
                try:
                    G.oHair.active_material=bpy.data.materials[G.o头皮.pp毛发o.sp材质];
                except:pass;
                
            
        #----生成UV-----------------------------------------
        if(G.oHair.pp毛发o.bp生成UV):
            if(Co视.active!=G.oHair):Co视.active=G.oHair;
            if(not G.mesh新.uv_layers):
                bpy.ops.mesh.uv_texture_add();
            G.dll.SetUV(c_void_p(G.oHair.data.as_pointer()),False);
        #----激活修正丄-----------------------------------------
        """
        bpy.ops.object.editmode_toggle();
        bpy.ops.mesh.normals_make_consistent(inside=True);
        bpy.ops.object.editmode_toggle();
        """
        if(not G.mesh新.use_auto_smooth):
            G.mesh新.use_auto_smooth=True;

        #G.mesh新.validate(clean_customdata=False);
        #if(G.oHair.pp毛发o.bp毛发数变了 or G.oHair.pp毛发o.bp1要updateO):

        #----权与颜色-------------------------------------------
        if(G.oHair.pp毛发o.bppin):
            if(self.b是新建毛发 or G.oHair.pp毛发o.bp毛发数变了):
                ΔΔ绑定权pin(G.oHair,G.CL2CLξ点pinG_);
        
        #----最后激活主物-----------------------------------------
        if(Co视.active!=G.oHair):Co视.active=G.oHair;
        G.mesh新.update(calc_edges=False, calc_edges_loose=False);
        #------------------------------
        if(context.scene.tool_settings.particle_edit.show_particles==True):
                context.scene.tool_settings.particle_edit.show_particles=False;#●●这个可以取子级缓存
        print("////HAIR EXE///////////////////////////////////////////////////////////////////////////////",);
        #bpy.ops.dele.dll_bl_hair('INVOKE_DEFAULT',);
        print("time6---->: %.3f" % (time.time() - time1));
        self.Δ恢复(G.oHair,G.oHair);
        #G.dll=dll卸载dll(G,"dll");#■■
        return {'FINISHED'    };
        pass;
        
        
#////end////end////end////end////end////end////end////end////







